export default class MathUtils{
    static clamp(x: number, min: number, max: number): number{
        if(x < min) return min;
        if(x > max) return max;
        return x;
    }

    static toHex(num: number, minLength: number = null): string{
        let factor = 1;
        while(factor*16 < num){
            factor *= 16;
        }
        let hexStr = "";
        while(num > 0){
            let digit = Math.floor(num/factor);
            hexStr += MathUtils.toHexDigit(digit);
            num -= digit * factor;
            factor /= 16;
		}
		
		if(minLength !== null){
			while(hexStr.length < minLength){
				hexStr = "0" + hexStr;
			}
		}

        return hexStr;
    }

    static toHexDigit(num: number): string{
        if(num < 10){
            return "" + num;
        } else {
            return String.fromCharCode(65 + num - 10);
        }
    }
}